"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

TBinding subclass:#TClassBinding
	instanceVariableNames:'clazz'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-Bindings'
!

!TClassBinding class methodsFor:'instance creation'!

clazz: aTClassDefinition
    ^ self new initializeWithClazz: aTClassDefinition

    "Created: / 02-09-2015 / 15:57:38 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

name: aString
    ^ self new initializeWithName: aString

    "Created: / 31-08-2015 / 11:21:27 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TClassBinding methodsFor:'accessing'!

clazz
   ^ clazz

    "Created: / 02-09-2015 / 15:58:14 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

type
   ^ TSimpleType named: clazz name

    "Created: / 31-08-2015 / 11:45:35 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified: / 02-09-2015 / 15:56:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TClassBinding methodsFor:'initialization'!

initializeWithClazz: aTClassDefinition
    clazz := aTClassDefinition

    "Created: / 02-09-2015 / 15:58:03 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TClassBinding methodsFor:'lookup'!

lookupMethodNamed: selector
    | method |

    method := clazz methodNamed: selector.
    method isNil ifTrue:[ 
        self error: ('Could not resolve method %1 >> #%2' bindWith: clazz name with: selector)  
    ].
    ^ method binding

    "Created: / 02-09-2015 / 16:06:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TClassBinding methodsFor:'testing'!

isClassBinding
    ^ true
! !

